% Workflow.m4
.PS
sinclude(CMman.dim)
s_init(Workflow)
gen_init
command "{\small\sf"

B:[
define(`fbox',`box fill_(0.95)')
command "\defboxdim{Workflow_a}{Postscript}"
define(`lbx',
`sprintf("\parbox{%gin}{\raggedleft $1}",boxdim(Workflow_a,h)/(1pt__)) rjust')

  boxwid = 0.58
  boxht = 0.4
  linethick_(1.0)
  arrowwid = 0.05
  arrowht = 0.1
  fillval = 0.8
  hsep = 0.08
  vsep = 0.15

Tpic:     fbox "\LaTeX"
Pict2e:   fbox "\LaTeX" "pict2e" with .w at Tpic.e+(hsep,0)
PSTricks: fbox "\LaTeX" "PSTricks" with .w at Pict2e.e+(hsep,0)
PGF: fbox "\LaTeX" "or" "PDFlatex" "tikz" ht 1.6*boxht \
  with .nw at PSTricks.ne+(hsep,0)
Mfpic: fbox "\LaTeX" "Mfpic" with .nw at PGF.ne+(hsep,0)
MetaFont: fbox "Metafont" with .n at Mfpic.s+(0,-vsep)
  arrow from Mfpic.s to MetaFont.n
  arrow from MetaFont.s down vsep/2 then right boxwid/2+hsep/2 \
    then up Mfpic.n.y-MetaFont.s.y+vsep*3/2 \
    then left hsep/2+boxwid/4 then down vsep
MetaPost: fbox "MetaPost" with .w at Mfpic.e+(hsep,0)
MPLaTeX: fbox ht boxht + vsep/2 "\LaTeX" "or" "PDFlatex" \
  with .n at MetaPost.s+(0,-vsep)
  arrow from MetaPost.s to MPLaTeX.n
Psfrag: fbox "\LaTeX" "psfrag" with .w at MetaPost.e+(hsep,0)

  boxstep = Pict2e.x-Tpic.x
  arlen = boxht*1.25
  arlen = 0.5*1.25

  arrow <- up arlen from Tpic.n lbx(tpic\\ {\tt \char92 special} \\.tex)
    command "\defboxdim{WQ}{{\tt \char92 special}}"
    move left boxdim(WQ,w)+2.5pt__ from last arrow

  arrow <- up arlen from Pict2e.n lbx(\LaTeX\\ .tex)
  "\tt -e" rjust above
  arrow <- up arlen from PSTricks.n lbx(PSTricks\\ .tex)
  "\tt -p" rjust above
  arrow <- up arlen from PGF.n lbx(PGF\\ .tex)
  "\tt -g" rjust above
  arrow <- up arlen from Mfpic.n lbx(mfpic\\ .tex)
  "\tt -m" rjust above
  arrow <- up arlen from MetaPost.n lbx(MetaPost\\ .mp)
  "\tt -s$\;$" rjust above
  arrow <- up arlen from Psfrag.n lbx(Postscript\\ psfrag\\ .eps)
  "\tt -f" rjust above
  arrow <- up arlen from last arrow.start+(boxstep,0) lbx(Postscript\\ .eps)
  "\tt -r" rjust above
  arrow <- up arlen from last arrow.start+(boxstep,0) lbx(Xfig\\ .fig)
  "\tt -x" rjust above

  line from Pict2e.n+(0,arlen) to last arrow.end
  arrow <- up vsep from last line.c
Dpic: fbox "dpic" with .s at Here

Gpic: fbox "gpic -t" at (Tpic,Dpic)
  line down vsep from Gpic.s
M4: fbox "m4" at 0.5<Gpic,Dpic>
  arrow from M4.e to Dpic.w
  arrow from M4.w to Gpic.e
  arrow <- up vsep from 1/3<M4.nw,M4.ne>
    `"\setbox0=\hbox{Diagram source}\raisebox{-\dp0}{\box0}"' rjust
  arrow <- up vsep from 2/3<M4.nw,M4.ne>
    `"Macro libraries"' ljust
]

# print last [].wid
  
command "}%"
.PE
